@echo off

IF NOT EXIST build mkdir build

SET CC_OPTS=--target=riscv32 -march=rv32ima -nostdlib -std=c23 -I.

clang %CC_OPTS% kernel\boot.s -c -o build\boot.o
clang %CC_OPTS% kernel\start.c -c -o build\start.o
clang %CC_OPTS% kernel\kalloc.c -c -o build\kalloc.o
clang %CC_OPTS% kernel\lib.c -c -o build\lib.o
clang %CC_OPTS% kernel\vm.c -c -o build\vm.o
clang %CC_OPTS% kernel\spinlock.c -c -o build\spinlock.o
clang %CC_OPTS% kernel\aplic.c -c -o build\aplic.o
clang %CC_OPTS% kernel\strap.s -c -o build\strap.o

ld.lld -T kernel\linker.lds -o build\kernel.elf ^
	build\boot.o ^
	build\start.o ^
	build\kalloc.o ^
	build\lib.o ^
	build\vm.o ^
	build\spinlock.o ^
	build\aplic.o ^
	build\strap.o ^
